/*
Copyright (C) 1999/2000 Hendrik Lipka.
All rights reserved.

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; 
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License 
for more details. 

You should have received a copy of the GNU General Public License along with this 
program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
Cambridge, MA 02139, USA or see http://www.gnu.org

If you encounter problems or have a suggestion, please mail to:
ldse@hendriklipka.de
*/

package de.hendriklipka.ldse.server.data.document;

import java.net.URL;
import java.util.Date;

import de.hendriklipka.ldse.server.data.URLInfo;
import de.hendriklipka.ldse.server.common.*;

public abstract class Document
{
  protected String _title=null;
  protected DocumentDescriptor _docDesc=null;
  protected Document[] _subDocuments=null;
  protected URLInfo _urlInfo=null;
  
  public void init(URLInfo urlInfo)
  {
    _docDesc=new DocumentDescriptor(-1,urlInfo._url,urlInfo._urlStr,urlInfo._spiderID,"","",
                                    urlInfo._lastChanged,urlInfo._checksum,urlInfo._size);
    _docDesc.setType(urlInfo._type);                                    
    _title=_docDesc.getUrlStr();
    if (null==_title)
      _title=urlInfo._urlStr;
    _urlInfo=urlInfo;
  }
  
  public abstract boolean hasMoreWords();
  public abstract String  nextWord();
  public abstract boolean init();
  public abstract void finish();
  public abstract String getDescriptiveWords();

  /**
    liefert alle Unterdokumente (Kapitel etc.)
  */
  public Document[] getSubDocuments()
  {
    return _subDocuments;
  }
  
  /**
    liefert die Metadaten
  */
  public DocumentDescriptor getDocDesc()
  {
    return _docDesc;
  }
  
  /**
    liefert den Titel
  */
  public String getTitle()
  {
    return _title;
  }
}